#include "system.h"
#include "basic_io.h"
#include "LCD.h"
#include "Test.h"
#include "sys/alt_irq.h"
#include "ImgButton.h"


//-------------------------------------------------------------------------//
//Case values for draw options
#define     Pencil      1
#define     Line        2
#define     Square      3
#define     Circle      4
#define     Polygon     5
#define     Erase       6
#define     Spray       7
#define     FillColor   8
#define     PickColor   9

//---------------------------- ---------------------------------------------//
//Boundary values of x and y co-ordinates
#define     displayColorAreaStartx      14
#define     displayColorAreaStarty      448
#define     displayColorAreaEndx        28
#define     displayColorAreaEndy        462
#define     drawingAreaStartx           47
#define     drawingAreaStarty           31
#define     drawingAreaEndx             636
#define     drawingAreaEndy             425

//-------------------------------------------------------------------------//
//LCD Control values
#define ESC_TOP_LEFT    "[1;0H"
#define ESC_BOTTOM_LEFT "[2;0H"
#define LCD_CLR "[2J"
#define LCD_CLR_LINE "[K"
static unsigned char esc = 0x1b; 
FILE * lcd_fd;


int maxmin(int no, int max, int min)
{
 if(no>max) {no=max;}
 if(no<min) {no=min;}

 return(no);
}

void play_mouse(unsigned int addr)
{
 unsigned int cbuf[128];
 unsigned int rbuf[128];

 //buffer information
 unsigned int atllen,ptllen,intllen;
 unsigned int int_start;

 //int parameters
 unsigned long int_skip=0xFFFFFFFE;
 unsigned long int_last=0x00000001;
 unsigned int  int_blk_size=64;

 unsigned int timecnt;
 unsigned int freq;

 signed char X=0,Y=0,B=0;

 unsigned int pX=320,pY=240;
 unsigned int oX=320,oY=240;

 unsigned int tog=0;
 
 int flag = 1, drawOption;
 int flag_pencil, flag_line, flag_square, flag_circle, flag_erase;
 int flag_spray, flag_polygon, flag_fillcolor, flag_pickcolor, flag_color;
 int start_x,start_y,end_x,end_y,initial_x,initial_y;
 int center_x,center_y,rad;
 int command,color=0,temp, cursor_type; 
 int erase_x1, erase_x2, erase_y1, erase_y2;
 int change_x, change_y, random, i, j;
 int x_limit, y_limit, currentColor, nextColor, m, initial_x_point, final_x_point;
 int erase_size = 1, square_type = 1, circle_type = 1;
 freq=0x00;
 erase_all();

 w16(HcBufStatus,0x00);

 //Setup Int Parameters
 w32(HcIntSkip,int_skip);
 w32(HcIntLast,int_last);
 w16(HcIntBlkSize,int_blk_size);

 //Setup Buffer
 atllen  =r16(HcATLLen);
 ptllen  =r16(HcPTLLen);
 intllen =r16(HcINTLen);

 int_start=ptllen+ptllen;
 cursor_type = 1;
 IOWR(CURSOR_TYPE_BASE,0,cursor_type);
 delay();
 delay();
 
 //background();
 //open the lcd --- device name from system.h
 lcd_fd = fopen("/dev/lcd_16207_0", "w");
 if(lcd_fd == NULL) printf("Unable to open lcd display\n"); 
 //Clear the LCD
 fprintf(lcd_fd, "%c%s", esc, LCD_CLR); 
   
 do
  {
   //send out DATA IN packet
   make_int_ptd(cbuf,IN,1,4,tog%2,addr,addr,freq);
   timecnt=send_int(cbuf,rbuf);
   //printf("%x\n",*rbuf);
   if(timecnt!=0)
   {
       X=(rbuf[4]>>8);
       Y=(rbuf[5]&0x00FF);
       B=(rbuf[4]&0x000F);
   }
   else
   {
       X=0;
       Y=0;
       B=0;
   }

   oX=pX;
   oY=pY;

   pX=pX+X;
   pY=pY+Y;

   pX=maxmin(pX,639,0);
   pY=maxmin(pY,479,0);
   printf("%d,%d\n",pX,pY);
   if(timecnt!=0) {tog++;}

   IOWR(SEG7_DISPLAY_BASE,0,(pX<<16)+pY);
   IOWR(LED_RED_BASE,0,pX);
   IOWR(LED_GREEN_BASE,0,pY);

   //Set_Cursor_XY(pX,pY);
   //Cursor - Mouse
   IOWR(X_CURSOR_BASE,0,pX-6);
   IOWR(Y_CURSOR_BASE,0,pY);
   
   if(B==1)
   {
        //Implementation of the functionality for Mouse Right Click
        //Displaying cursor position in the console area
        printf("%d,%d\n",pX,pY);
        
        //Choice of color 
        //Bottom row
        if((pX >= 45 && pX <= 59)  && (pY >= 457 && pY <= 469))
        {  
            color = 0xFFFF;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 62 && pX <= 75)  && (pY >= 457 && pY <= 469))
        {
            color = 0xB6B6;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);continue;
        }
        else if((pX >= 78 && pX <= 90)  && (pY >= 457 && pY <= 469))
        {
            color = 0xE0E0;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);continue;
        }
        else if((pX >= 94 && pX <= 107)  && (pY >= 457 && pY <= 469))
        {
            color = 0xFCFC;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);continue;
        }
        else if((pX >= 109 && pX <= 122)  && (pY >= 457 && pY <= 469))
        {
            color = 0x1C1C;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);continue;
        }
        else if((pX >= 126 && pX <= 139)  && (pY >= 457 && pY <= 469))
        {
            color = 0x1F1F;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 142 && pX <= 155)  && (pY >= 457 && pY <= 469))
        {
            color = 0x0303;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 158 && pX <= 170)  && (pY >= 457 && pY <= 469))
        {
            color = 0xE3E3; 
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 173 && pX <= 187)  && (pY >= 457 && pY <= 469))
        {
            color = 0xFEFE;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 190 && pX <= 203)  && (pY >= 457 && pY <= 469))
        {
            color = 0x1E1E;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 206 && pX <= 219)  && (pY >= 457 && pY <= 469))
        {
            color = 0x9F9F;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 222 && pX <= 235)  && (pY >= 457 && pY <= 469))
        {
            color = 0x9393; 
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 238 && pX <= 251)  && (pY >= 457 && pY <= 469))
        {
            color = 0xE2E2;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 254 && pX <= 267)  && (pY >= 457 && pY <= 469))
        {
            color = 0xF1F1;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        
        //Top row
        else if((pX >= 45 && pX <= 59)  && (pY >= 441 && pY <= 452))
        {
            color = 0x0000;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 62 && pX <= 74)  && (pY >= 441 && pY <= 452))
        {
            color = 0x9292;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 78 && pX <= 90)  && (pY >= 441 && pY <= 452))
        {
            color = 0x8080;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 94 && pX <= 107)  && (pY >= 441 && pY <= 452))
        {
            color = 0x9090;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 109 && pX <= 122)  && (pY >= 441 && pY <= 452))
        {
            color = 0x1010;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 126 && pX <= 139)  && (pY >= 441 && pY <= 452))
        {
            color = 0x1212;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 142 && pX <= 155)  && (pY >= 441 && pY <= 452))
        {
            color = 0x0202;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 158 && pX <= 170)  && (pY >= 441 && pY <= 452))
        {
            color = 0x8282;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 173 && pX <= 187)  && (pY >= 441 && pY <= 452))
        {
            color = 0x9191; 
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 190 && pX <= 203)  && (pY >= 441 && pY <= 452))
        {
            color = 0x0909;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 206 && pX <= 219)  && (pY >= 441 && pY <= 452))
        {
            color = 0x1313;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 222 && pX <= 235)  && (pY >= 441 && pY <= 452))
        {
            color = 0x0A0A;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 238 && pX <= 251)  && (pY >= 441 && pY <= 452))
        {
            color = 0x8383;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        else if((pX >= 254 && pX <= 267)  && (pY >= 441 && pY <= 452))
        {
            color = 0x8888;
            displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
            continue;
        }
        //End of color choice
   
        //------------------------------------------------------------------------------//
        
        //Choice of pattern to draw
        //Pencil
        if((pX >= 11 && pX <= 33)  && (pY >= 30 && pY <= 54))
        {
            //Clearing the options area
            clearOption();
            
            //Setting the cursor type
            cursor_type = 1;
            IOWR(CURSOR_TYPE_BASE,0,cursor_type);
            
            //Setting the appropiate flags
            drawOption = Pencil;
            flag_pencil = 1;
            
            //Displaying the choice on the LCD
            fprintf(lcd_fd, "%c%s", esc, LCD_CLR); 
            fprintf(lcd_fd, "%c%sPencil\n", esc, ESC_TOP_LEFT);
        }
        
        //Line
        else if((pX >= 11 && pX <= 33)  && (pY >= 58 && pY <= 81))
        {
            //Clearing the options area
            clearOption();
            
            //Setting the cursor type
            cursor_type = 1;
            IOWR(CURSOR_TYPE_BASE,0,cursor_type);
            
            //Setting the appropiate flags
            drawOption = Line;
            flag_line = 1;
            
            //Displaying the choice on the LCD
            fprintf(lcd_fd, "%c%s", esc, LCD_CLR); 
            fprintf(lcd_fd, "%c%sLine\n", esc, ESC_TOP_LEFT);
            continue;
        }
        
        //Square
        else if((pX >= 11 && pX <= 33)  && (pY >= 87 && pY <= 108))
        {
            //Displaying square options in the options area
            squareOptions();
            
            //Setting the cursor type
            cursor_type = 1;
            IOWR(CURSOR_TYPE_BASE,0,cursor_type);
                        
            //Setting the appropiate flags
            drawOption = Square;
            flag_square = 1;
            
            //Displaying the choice on the LCD
            fprintf(lcd_fd, "%c%s", esc, LCD_CLR); 
            fprintf(lcd_fd, "%c%sSquare\n", esc, ESC_TOP_LEFT);
            continue;
        }
        
        //Circle
        else if((pX >= 11 && pX <= 33)  && (pY >= 113 && pY <= 138))
        {
            //Displaying circle options in the options area
            circleOptions();
            
            //Setting the cursor type
            cursor_type = 1;
            IOWR(CURSOR_TYPE_BASE,0,cursor_type);
            
            //Setting the appropiate flags
            drawOption = Circle;
            flag_circle = 1;
            
            //Displaying the choice on the LCD
            fprintf(lcd_fd, "%c%s", esc, LCD_CLR); 
            fprintf(lcd_fd, "%c%sCircle\n", esc, ESC_TOP_LEFT);
            continue;
        }
        
        //Polygon
        else if((pX >= 11 && pX <= 33)  && (pY >= 141 && pY <= 166))
        {
            //Clearing the options area
            clearOption();
            
            //Setting the cursor type
            cursor_type = 1;
            IOWR(CURSOR_TYPE_BASE,0,cursor_type);
            
            //Setting the appropiate flags
            drawOption = Polygon;
            flag_polygon = 1;
            
            //Displaying the choice on the LCD
            fprintf(lcd_fd, "%c%s", esc, LCD_CLR); 
            fprintf(lcd_fd, "%c%sPolygon\n", esc, ESC_TOP_LEFT);
            continue;
        }
        
        //Eraser
        else if((pX >= 11 && pX <= 33)  && (pY >= 170 && pY <= 194))
        {
            //Displaying the eraser options in the options area
            eraseOptions();
            
            //Setting the cursor type
            cursor_type = 2;
            IOWR(CURSOR_TYPE_BASE,0,cursor_type);
            
            //Setting the appropiate flags
            drawOption = Erase;
            flag_erase = 1;
            
            //Displaying the choice on the LCD
            fprintf(lcd_fd, "%c%s", esc, LCD_CLR); 
            fprintf(lcd_fd, "%c%sEraser\n", esc, ESC_TOP_LEFT);
            continue;
        }
        
        //Spray
        else if((pX >= 11 && pX <= 33)  && (pY >= 198 && pY <= 222))
        {
            //Clearing the options area
            clearOption();
            
            //Setting the cursor type
            cursor_type = 1;
            IOWR(CURSOR_TYPE_BASE,0,cursor_type);
            
            //Setting the appropiate flags
            drawOption = Spray;
            flag_spray = 1;
            
            //Displaying the choice on the LCD
            fprintf(lcd_fd, "%c%s", esc, LCD_CLR); 
            fprintf(lcd_fd, "%c%sSpray\n", esc, ESC_TOP_LEFT);
            continue;
        }
        
        // Fill Color
        else if((pX >= 11 && pX <= 33)  && (pY >= 225 && pY <= 250))
        {
            //Clearing the options area
            clearOption();
            
            //Setting the cursor type
            cursor_type = 1;
            IOWR(CURSOR_TYPE_BASE,0,cursor_type);
            
            //Setting the appropiate flags
            drawOption = FillColor;
            flag_fillcolor = 1;
            
            //Displaying the choice on the LCD
            fprintf(lcd_fd, "%c%s", esc, LCD_CLR); 
            fprintf(lcd_fd, "%c%sFill Color\n", esc, ESC_TOP_LEFT);
            continue;
        }
        
        // Pick Color
        else if((pX >= 11 && pX <= 33)  && (pY >= 253 && pY <= 277))
        {
            //Clearing the options area
            clearOption();
            
            //Setting the cursor type
            cursor_type = 1;
            IOWR(CURSOR_TYPE_BASE,0,cursor_type);
            
            //Setting the appropiate flags
            drawOption = PickColor;
            flag_pickcolor = 1;
            
            //Displaying the choice on the LCD
            fprintf(lcd_fd, "%c%s", esc, LCD_CLR); 
            fprintf(lcd_fd, "%c%sPick Color\n", esc, ESC_TOP_LEFT);
            continue;
        }
        
        //Clear Area
        else if ((pX >= 11 && pX <= 33) && (pY >= 280 && pY <= 305))
        {
            //Clearing the options area
            clearOption();
            
            //Setting the cursor type
            cursor_type = 1;
            IOWR(CURSOR_TYPE_BASE,0,cursor_type);
            
            //Displaying the choice on the LCD
            fprintf(lcd_fd, "%c%s", esc, LCD_CLR); 
            fprintf(lcd_fd, "%c%sClearing ... \n", esc, ESC_TOP_LEFT);
            
            //Calling the module to clear the drawing area
            clearArea();
            
            //Setting the option back to pencil after clearing the screen
            drawOption = Pencil;
            continue;
        }
        
        //Eraser Options
        else if ((drawOption == Erase) && (pX >= 21 && pX <= 26) && (pY >= 316 && pY <= 319))
        {
            cursor_type = 2;
            IOWR(CURSOR_TYPE_BASE,0,cursor_type);
            erase_size = 1;
            continue;
        }
        else if ((drawOption == Erase) && (pX >= 20 && pX <= 28) && (pY >= 326 && pY <= 332))
        {
            cursor_type = 3;
            IOWR(CURSOR_TYPE_BASE,0,cursor_type);
            erase_size = 2;
            continue;
        }
        else if ((drawOption == Erase) && (pX >= 19 && pX <= 28) && (pY >= 340 && pY <= 347))
        {
            cursor_type = 4;
            IOWR(CURSOR_TYPE_BASE,0,cursor_type);
            erase_size = 3;
            continue;
        }
        
        //Square Options
        else if ((drawOption == Square) && (pX >= 16 && pX <= 31) && (pY >= 318 && pY <= 332))
        {
            square_type = 1;
            continue;
        }
        else if ((drawOption == Square) && (pX >= 16 && pX <= 31) && (pY >= 344 && pY <= 357))
        {
            square_type = 2;
            continue;
        }
        
        //Circle Options
        else if ((drawOption == Circle) && (pX >= 15 && pX <= 34) && (pY >= 317 && pY <= 331))
        {
            circle_type = 1;
            continue;
        }
        else if ((drawOption == Circle) && (pX >= 15 && pX <= 34) && (pY >= 343 && pY <= 358))
        {
            circle_type = 2;
            continue;
        }
        //Saving File
//        else if ((pX >= 11 && pX <= 33) && (pY >= 370 && pY <= 400))
//        {
//            clearOption();
//            fprintf(lcd_fd, "%c%s", esc, LCD_CLR); 
//            fprintf(lcd_fd, "%c%sSaving File\n", esc, ESC_TOP_LEFT);
//            saveFile();
//            continue;
//        }
        //End of pattern choice
        
        //-------------------------------------------------------------------------//
 
        //Switch case statements
        switch(drawOption)
        {
            case Pencil:
            {
                if (flag_pencil == 1)
                {
                    flag_pencil = 2;
                    continue;
                }
                else if(flag_pencil==2)
                {
                    PutPixel(pX,pY,color);                
                    break;                
                }
            }  // case Pencil
        
            case Line:
            {
                 if (flag_line == 1)
                 {
                    start_x = pX;
                    start_y = pY;
                    flag_line = 2;
                    printf("Start Point : %d,%d \n",start_x,start_y);
                    continue;
                 }
                 else if(flag_line == 2)
                 {
                    end_x = pX;
                    end_y = pY;
                    flag_line = 1;
                    printf("End Point : %d,%d \n",end_x,end_y);
                    Bresenham(start_x,start_y,end_x,end_y,color);
                    break;
                 } 
            }  // case Line
                   
            case Square:
            {
                 if (flag_square == 1)
                 {
                    start_x = pX;
                    start_y = pY;
                    flag_square = 2;
                    printf("Start Point : %d,%d \n",start_x,start_y);
                    continue;
                 }
                 else if(flag_square == 2)
                 {
                    end_x = pX;
                    end_y = pY;
                    flag_square = 1;
                    printf("End Point : %d,%d \n",end_x,end_y);
                    if(square_type == 1)
                    {
                        DrawSquare(start_x,start_y,end_x,end_y,color);
                    }
                    else if (square_type == 2)
                    {
                        FillSquare(start_x,start_y,end_x,end_y,color);
                    }
                    break;             
                  } 
              }  // case Square
              
              case Circle:
              {
                 if (flag_circle == 1)
                 {
                    start_x = pX;
                    start_y = pY;
                    flag_circle = 2;
                    printf("Start Point : %d,%d \n",start_x,start_y);
                    continue;
                 }
                 else if(flag_circle == 2)
                 {
                    end_x = pX;
                    end_y = pY;
                    flag_circle = 1;
                    printf("End Point : %d,%d \n",end_x,end_y);
                    //Calculate center and radius
                    center_x = (int)(start_x + end_x)/2;
                    center_y = start_y;
                    if (end_x >= start_x)
                    {
                        rad = (int)(end_x - start_x)/2;
                    }
                    else
                    {
                        rad = (int)(start_x - end_x)/2;
                    }
                    //Send these values to DrawCircle module
                    if(circle_type == 1)
                    {
                        DrawCircle(center_x, center_y, rad, color);
                    }
                    else if (circle_type == 2)
                    {
                        FillCircle(center_x, center_y, rad, color);
                    }
                    break;             
                  } 
                               
               }  // case Circle
               
               case Polygon:
               {
                 if (flag_polygon == 1)
                 {
                    start_x = pX;
                    start_y = pY;
                    initial_x = pX;
                    initial_y = pY;
                    flag_polygon = 2;
                    printf("Start Point : %d,%d \n",start_x,start_y);
                    continue;
                 }
                 else if(flag_polygon == 2)
                 {
                    end_x = pX;
                    end_y = pY;
                    printf("End Point : %d,%d \n",end_x,end_y);
                    Bresenham(initial_x,initial_y,end_x,end_y,color);
                    initial_x = end_x;
                    initial_y = end_y;                   
                    //flag_polygon = 2;
                    if( (pX == start_x && pY == start_y)     ||
                        (pX == start_x && pY == start_y+1)   ||
                        (pX == start_x && pY == start_y-1)   ||
                        (pX == start_x+1 && pY == start_y)   ||
                        (pX == start_x+1 && pY == start_y+1) ||
                        (pX == start_x+1 && pY == start_y-1) ||
                        (pX == start_x-1 && pY == start_y)   ||
                        (pX == start_x-1 && pY == start_y+1) ||
                        (pX == start_x-1 && pY == start_y-1)
                      )
                        {
                            Bresenham(start_x, start_y,initial_x,initial_y,color);
                            flag_polygon = 1;
                        }
                        break;
                 }
               }  // case Polygon
               
               case Erase:
               {
                 if (flag_erase == 1)
                 {
                    flag_erase = 2;
                    continue;
                 }
                 else if(flag_erase == 2)
                 {
                    erase_x1 = pX-erase_size;
                    erase_y1 = pY-erase_size;
                    erase_x2 = pX+erase_size;
                    erase_y2 = pY+erase_size;
                    
                    FillSquare(erase_x1, erase_y1, erase_x2, erase_y2, 0xFFFF);
                    break;             
                  } 
              } // case Erase
              
              case Spray:
              {
                 if (flag_spray == 1)
                 {
                    flag_spray = 2;
                    continue;
                 }
                 else if(flag_spray == 2)
                 {
                    sprayColor(pX,pY,color);
                    break;             
                  } 
              } // case Spray
              
              case FillColor:
              {
                if(flag_fillcolor == 1)
                {
                    start_x = pX;
                    start_y = pY;
                    flag_fillcolor =2;
                    flag_color =1;
                    continue;
                }
                else if (flag_fillcolor == 2)
                {
                    end_x = pX;
                    end_y = pY;
                    
                    for(y_limit=start_y; y_limit<end_y; y_limit++)
                    {
                        for(x_limit=start_x; x_limit<end_x; x_limit=x_limit+2)
                        {
                            currentColor = GetPixel(x_limit,y_limit);
                            nextColor = GetPixel(x_limit+2,y_limit);
                            if(currentColor != nextColor)
                            {
                                if (flag_color == 1)
                                {
                                    initial_x_point = x_limit+2;
                                    flag_color = 2;
                                    continue;
                                }
                                else if (flag_color == 2)
                                {   
                                    final_x_point = x_limit+2;
                                    for(m=initial_x_point;m<=final_x_point;m++)
                                    {
                                        PutPixel(m,y_limit,color);
                                    }
                                    flag_color = 1;
                                    break;
                                }
                            }
                        }
                    }
                    //flag_fillcolor = 2;
                    break;
                }
                
              }  // case FillColor
              
              // Start Case PickColor
              case PickColor:
              {
                 if (flag_pickcolor == 1)
                 {
                    color = GetPixel(pX,pY);
                    displayColor(displayColorAreaStartx, displayColorAreaStarty, displayColorAreaEndx, displayColorAreaEndy, color);
                    break;
                 }
              } 
              // End Case PickColor
              
           } 
           //End of Switch statement
      } 
      
      else if(B==2)
      {
        //Implementation of the functionality for Mouse Right Click
      }
   
  }
  while((r16(HcRhP2) & 0x01) ==0x01);
     printf("\nMouse Not Detected");
}

void mouse(void)
{
 unsigned int rbuf[128];
 unsigned int dev_req[4]={0x0680,0x0100,0x0000,0x0008};
 unsigned int uni_req[4]={0x0500,3,0x0000,0x0000};

 //buffer information
 unsigned int atllen,ptllen,intllen;
 unsigned int atl_start;

 //atl parameters
 unsigned long atl_skip=0xFFFFFFFE;
 unsigned long atl_done=0;
 unsigned long atl_last=0x00000001;
 unsigned int  atl_blk_size=64;
 unsigned int  atl_cnt=1;
 unsigned int  atl_timeout=200;
 unsigned int mycode;
 unsigned int iManufacturer,iProduct;
 unsigned int starty=5;
 unsigned int status;
 unsigned int mouse01=0,mouse02=0;
 unsigned int g=0;

while(1)
{
  dev_req[0]=0x0680;
  dev_req[1]=0x0100;
  dev_req[2]=0x0000;
  dev_req[3]=0x0008;
  uni_req[0]=0x0500;
  uni_req[1]=3;
  uni_req[2]=0x0000;
  uni_req[3]=0x0000;


 //atl parameters
  atl_skip=0xFFFFFFFE;
  atl_done=0;
  atl_last=0x00000001;
  atl_blk_size=64;
  atl_cnt=1;
  atl_timeout=200;
  starty=5;
  mouse01=0,mouse02=0;
 

 set_operational();
 enable_port();

// reset_usb();
 erase_all();
 set_operational();
 enable_port();

 
 w16(HcControl,0x6c0);
 w16(HcUpInt,0x1a9);
 //delay(300);

 w16(HcBufStatus,0x00);

 //Setup ATL Parameters
 w32(HcATLSkip,atl_skip);
 w32(HcATLLast,atl_last);
 w16(HcATLBlkSize,atl_blk_size);
 w16(HcATLThrsCnt,atl_cnt);
 w16(HcATLTimeOut,atl_timeout);

 //Setup ATL Buffer
 atllen  =r16(HcATLLen);
 ptllen  =r16(HcPTLLen);
 intllen =r16(HcINTLen);

 atl_start=ptllen+ptllen+intllen;

 status=assign_address(1,2,0);
 status=assign_address(1,2,0);

 if(g==0)
 {
  printf("ISP1362 Mouse Demo.....\n");
  g=1;
 }

 w16(HcUpIntEnable,0x120);

 if( (status&0x0001)!=0) //port 2 active
 {
//  Check port 2 for mouse
  mycode=get_control(rbuf,2,'D',0,2);
  if(mycode==0x0300)
  {
   iManufacturer = rbuf[7]&0xFF;
   iProduct = (rbuf[7]&0xFF00)>>8;
   addr_info(2,'W','O',iManufacturer);
   addr_info(2,'W','P',iProduct);
   mycode=get_control(rbuf,2,'H',addr_info(2,'R','P',0),2);
   if( *(rbuf+1)==0x0209  )
   {
       printf("\nMouse Detected");
       mouse02=1;
   }
  }
 }

 if((mouse02==1)&&(mouse01==0))
 {
  mycode=set_config(2,1);
  if(mycode==0)
  play_mouse(2);
 }
 usleep(100000);
}
}

//-------------------------------------------------------------------------//
//Case values for draw options
#define     Pencil      1
#define     Line        2
#define     Square      3
#define     Circle      4
#define     Polygon     5
#define     Erase       6
#define     Spray       7
#define     FillColor   8
#define     PickColor   9


//-------------------------------------------------------------------------//
//Boundary values of x and y co-ordinates
#define     displayColorAreaStartx      14
#define     displayColorAreaStarty      448
#define     displayColorAreaEndx        28
#define     displayColorAreaEndy        462
#define     drawingAreaStartx           47
#define     drawingAreaStarty           31
#define     drawingAreaEndx             636
#define     drawingAreaEndy             425

//-------------------------------------------------------------------------//


//To draw a line
Bresenham(int x1, int y1, int x2, int y2,int color)
{
            int slope;
            int dx, dy, incE, incNE, d, x, y;
            int flag_dydx = 0, temp1,steep;
            int abs_dx , abs_dy;
            // Reverse lines where x1 > x2
            
            abs_dx = abs(x2 - x1);
            abs_dy = abs(y2 - y1);
            if(abs_dy > abs_dx)
            {
                steep = 1;
            }
            else
            {
                steep = 0;
            }
            
            if(steep ==1)
            {
                
               //swap(x1,y1) and swap(x2,y1)
                temp1 = x1;
                x1 = y1;
                y1 = temp1;
                
                temp1 = x2;
                x2 = y2;
                y2 = temp1;
                                
               
            }
             if (x1 > x2)
            {
                //Bresenham(x2, y2, x1, y1);
                temp1 = x1;
                x1 = x2;
                x2 = temp1;
                
                temp1 = y1;
                y1 = y2;
                y2 = temp1;
                //return;
            }
            dx = x2 - x1;
            dy = y2 - y1;                      
            // Adjust y-increment for negatively sloped lines
            if (dy < 0)
            {
                slope = -1;
                dy = -dy;
            }
            else
            {
                slope = 1;
            }
            // Bresenham constants
            incE = 2 * dy;
            incNE = 2 * dy - 2 * dx;
            d = 2 * dy - dx;
            y = y1;
            // Blit
            for (x = x1; x <= x2; x++)
            {
               if(steep == 1)
               {
                 PutDoublePixel(y,x,color);
               }
               else
               {
                 PutDoublePixel(x,y,color);
               }
                if (d <= 0)
                {
                    d += incE;
                }
                else
                {
                    d += incNE;
                    y += slope;
                    
                }
            }
}

//To draw a square
DrawSquare(int x1, int y1, int x2, int y2,int color)
{
            Bresenham(x1,y1,x1,y2,color);
            delay();
            Bresenham(x1,y2,x2,y2,color);
            delay();
            Bresenham(x2,y2,x2,y1,color);
            delay();
            Bresenham(x2,y1,x1,y1,color);
            delay();
}

//To fill the color      
FillSquare(int x1, int y1, int x2, int y2, int color)
{
            unsigned int i,j,temp;
            printf("\ninside fill"); 
            if (x1>x2)
            {
                temp=x1;
                x1 = x2;
                x2 = temp;
            }  
            if (y1>y2)
            {
                temp=y1;
                y1 = y2;
                y2 = temp;
            }           
            for (i=x1; i<=x2; i++)
            { 
                for (j=y1; j<=y2; j++)
                {
                    PutDoublePixel(i,j,color);
                }
            }
}

//To draw a circle
DrawCircle(int x0, int y0, int radius, int color)
{
   int x_plus, y_plus;
   int f = 1 - radius;
   int ddF_x = 0;
   int ddF_y = -2 * radius;
   int x = 0;
   int y = radius;
    
   printf("\n x0 and y0 : %d , %d", x0,y0);
   printf("\n radius : %d \n", radius);
   
   y_plus = y0 +radius;
   PutDoublePixel(x0, y_plus, color);
   delay();
   delay();
   
   y_plus = y0 - radius;
   PutDoublePixel(x0, y_plus, color);
   delay();
   delay();
   
   x_plus = x0 + radius;
   PutDoublePixel(x_plus, y0, color);
   delay();
   delay();
   
   x_plus = x0 - radius;
   PutDoublePixel(x_plus, y0, color);
   delay();
   delay();
   
   while(x < y) 
   {
     if(f >= 0) 
     {
       y--;
       ddF_y += 2;
       f += ddF_y;
     }
     x++;
     ddF_x += 2;
     f += ddF_x + 1;    
     
     x_plus = x0 + x;
     y_plus = y0 + y;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
     
     x_plus = x0 - x;
     y_plus = y0 + y;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
     
     x_plus = x0 + x;
     y_plus = y0 - y;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
     
     x_plus = x0 - x;
     y_plus = y0 - y;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
     
     x_plus = x0 + y;
     y_plus = y0 + x;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
     
     
     x_plus = x0 - y;
     y_plus = y0 + x;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
     
     x_plus = x0 + y;
     y_plus = y0 - x;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
          
     x_plus = x0 - y;
     y_plus = y0 - x;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
     
   }
}

//To draw a circle
DrawFillCircle(int x0, int y0, int radius, int color)
{
   int x_plus, y_plus;
   int f = 1 - radius;
   int ddF_x = 0;
   int ddF_y = -2 * radius;
   int x = 0;
   int y = radius;
    
   printf("\n x0 and y0 : %d , %d", x0,y0);
   printf("\n radius : %d \n", radius);
   
   y_plus = y0 +radius;
   PutDoublePixel(x0, y_plus, color);
   delay();
   delay();
   
   y_plus = y0 - radius;
   PutDoublePixel(x0, y_plus, color);
   delay();
   delay();
   
   x_plus = x0 + radius;
   PutDoublePixel(x_plus, y0, color);
   delay();
   delay();
   
   x_plus = x0 - radius;
   PutDoublePixel(x_plus, y0, color);
   delay();
   delay();
   
   while(x < y) 
   {
     if(f >= 0) 
     {
       y--;
       ddF_y += 2;
       f += ddF_y;
     }
     x++;
     ddF_x += 2;
     f += ddF_x + 1;    
     
     x_plus = x0 + x;
     y_plus = y0 + y;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
     
     x_plus = x0 - x;
     y_plus = y0 + y;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
     
     x_plus = x0 + x;
     y_plus = y0 - y;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
     
     x_plus = x0 - x;
     y_plus = y0 - y;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
     
     x_plus = x0 + y;
     y_plus = y0 + x;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
     
     
     x_plus = x0 - y;
     y_plus = y0 + x;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
     
     x_plus = x0 + y;
     y_plus = y0 - x;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
          
     x_plus = x0 - y;
     y_plus = y0 - x;
     PutDoublePixel(x_plus, y_plus, color);
     delay();
     delay();
     
   }
}


FillCircle(int x0, int y0, int radius, int color)
{
   int i;
   
   for(i=radius;i>=1;i--) 
    {
        DrawFillCircle(x0, y0, i, color);
        delay();
    }
    
}

//Delay in the values to VGA         
delay()
{
    int i,max;
    max = 1000;
    for(i=0;i<max;i++);
}

//Testing of background
void background()
{
    int i,j;
    
    for(i=0;i< 20; i++)
    {
        for(j=0;j< 480 ; j++)
        {
        IOWR(COMMAND_BASE,0,1);
        IOWR(X_PTR_BASE,0,i);
        IOWR(Y_PTR_BASE,0,j);
        IOWR(COLOR_BASE,0,0xFFFF);
        delay();
        }
    }
}

//Writing the pixel on the VGA
PutPixel(int x,int y, int color)
{
    int command = 1;
    int BGColor;
    int ForeColor;
    
    if (x%2 == 0)
    {
        BGColor = GetPixel(x,y);
        BGColor = BGColor >> 8;
        BGColor = BGColor & 0x00FF;
        color = color & 0xFF00;
        ForeColor= color | BGColor;
    }
    else
    {
        BGColor = GetPixel(x,y);
        BGColor = BGColor & 0xFF00;
        color = color & 0x00FF;
        ForeColor= color | BGColor;
    }
    
    if ((x >= drawingAreaStartx && x <= drawingAreaEndx) && (y >= drawingAreaStarty && y <= drawingAreaEndy))
    {
        IOWR(COMMAND_BASE,0,command);
        IOWR(X_PTR_BASE,0,x);
        IOWR(Y_PTR_BASE,0,y);
        IOWR(COLOR_BASE,0,ForeColor);
        delay();  
    }   
}

//Writing the pixel on the VGA
PutDoublePixel(int x,int y, int color)
{
    int command = 1;
    
    if ((x >= drawingAreaStartx && x <= drawingAreaEndx) && (y >= drawingAreaStarty && y <= drawingAreaEndy))
    {
        IOWR(COMMAND_BASE,0,command);
        IOWR(X_PTR_BASE,0,x);
        IOWR(Y_PTR_BASE,0,y);
        IOWR(COLOR_BASE,0,color);
        delay();  
    }   
}

//Clear the drawing area
clearArea()
{
    unsigned int x,y,color;
    color=0xFFFF;
    
    for(y=drawingAreaStarty; y<drawingAreaEndy; y++) 
    {
        for(x=drawingAreaStartx; x<drawingAreaEndx; x++)
        {
            PutDoublePixel(x,y,color);
        }
    }
}

//Writing the pixel on the VGA
initialPutPixel(int x,int y, int color)
{
    int command = 1;
    IOWR(COMMAND_BASE,0,command);
    IOWR(X_PTR_BASE,0,x);
    IOWR(Y_PTR_BASE,0,y);
    IOWR(COLOR_BASE,0,color);
    delay();
}

FillArea(int x, int y, int color)
{
    int readColor, readYcolor;
    int command;
    int i,j;
    int temp_x, temp_y;
    printf("Inside Fill Area \n Color : %d \n", color);
    
    
//    do
//        {
//           
//            temp = readColor;
//            readColor = GetPixel(i,j);
//            printf("readColor : %d\n",readColor);
//            delay();
//            delay();
//            PutPixel(i,j,color);
//            delay();
//            delay();
//            i= i+2;
//            
//                    
//        }while(readColor == temp);

    j=y;
    i=x;
    temp_x =  GetPixel(i,j);
    readColor = GetPixel(i,j);
    temp_y = GetPixel(i,j);
    readYcolor = GetPixel(x,j);
  
    do
    {
        i = x;
         do
        {
           
            temp_x = readColor;
            readColor = GetPixel(i,j);
            printf("readColor : %d\n",readColor);
            delay();
            delay();
            PutPixel(i,j,color);
            delay();
            delay();
            i= i+2;
            
                    
        }while(readColor == temp_x);
        
        temp_y = readYcolor;
        readYcolor = GetPixel(x,j);
        printf("readYcolor : %d\n",readYcolor);         
        
        delay();
        delay();
        j++;
    }while (readYcolor == temp_y);
    
    j=y;
    i=x;
    temp_x =  GetPixel(i,j);
    readColor = GetPixel(i,j);
    temp_y = GetPixel(i,j);
    readYcolor = GetPixel(x,j);
    do
    {
        i = x;
         do
        {
           
            temp_x = readColor;
            readColor = GetPixel(i,j);
            printf("readColor : %d\n",readColor);
            delay();
            delay();
            PutPixel(i,j,color);
            delay();
            delay();
            i= i-2;
            
                    
        }while(readColor == temp_x);
        
        temp_y = readYcolor;
        readYcolor = GetPixel(x,j);
        printf("readYcolor : %d\n",readYcolor);         
        
        delay();
        delay();
        j++;
    }while (readYcolor == temp_y);
    
}

int GetPixel(int x, int y)
{
    int command, readColor;  
    
    command = 2;
    IOWR(COMMAND_BASE,0,command);
    delay();
    delay();
    IOWR(X_READ_BASE, 0,x);
    delay();
    delay();
    
    IOWR(Y_READ_BASE, 0,y);
    delay();
    delay();    
    
    readColor = IORD(READ_COLOR_BASE,0);
    delay();
    delay();
    
    //printf("Color Read from VGA: %d", readColor);
    return(readColor);
        
}

//Module for generating random numbers (either 0 or 1)
generateRandom(int x, int y, int color)
{
   int random;
   random = rand()/(int)(((unsigned)RAND_MAX + 1) / 2);
   if (random == 0)
   PutPixel(x,y,color);   
}

//Module for Spray color logic
sprayColor(int x, int y, int color)
{
        int change_x, change_y;
        int i,j1,j2,k;
        printf("inside spray\n");
        j1 = y;
        j2 = y;
        
        for(k=4;k>=0;k--)
        {
            for(i=x-k;i <= x+k;i++)
            {
                generateRandom(i,j1,color);
                generateRandom(i,j2,color);
            }
            j1--;
            j2++;
        }
}

//--------------------------------------------------------------------------------------//
//Module for displaying the choosen color      
displayColor(int x1, int y1, int x2, int y2, int color)
{
        unsigned int i,j;
        
        for (i=x1; i<=x2; i++)
        { 
            for (j=y1; j<=y2; j++)
            {
                initialPutPixel(i,j,color);
            }
        }
}

//--------------------------------------------------------------------------------------//
//Module for displaying the various option choices
//1. Circle options
circleOptions()
{
    unsigned int x,y,i,b;
    i=0;
    
    for(y=310;y<370;y++) 
    {
        for(x=10;x<36;x=x+2)
        {
            b= circle_options[i] << 8;
            b = b | circle_options[i+1];
            initialPutPixel(x,y,b);
            delay();
            i=i+2;
        }
    }
}

//2. Square options
squareOptions()
{
    unsigned int x,y,i,b;
    i=0;
    
    for(y=312;y<372;y++) 
    {
        for(x=12;x<38;x=x+2)
        {
            b= square_options[i] << 8;
            b = b | square_options[i+1];
            initialPutPixel(x,y,b);
            delay();
            i=i+2;
        }
    }
}

//3. Erase options
eraseOptions()
{
    unsigned int x,y,i,b;
    i=0;
    
    for(y=310;y<370;y++) 
    {
        for(x=15;x<41;x=x+2)
        {
            b= erase_options[i] << 8;
            b = b | erase_options[i+1];
            initialPutPixel(x,y,b);
            delay();
            i=i+2;
        }
    }
}

//4. Clear option (clears any of the options chosen above)
clearOption()
{
    unsigned int x,y,i,b;
    i=0;
    
    for(y=310;y<370;y++) 
    {
        for(x=10;x<36;x=x+2)
        {
            b= clear_option[i] << 8;
            b = b | clear_option[i+1];
            initialPutPixel(x,y,b);
            delay();
            i=i+2;
        }
    }
}

//--------------------------------------------------------------------------------------//

//Module for saving the image present in the display area
saveFile()
{
    unsigned int x,y,i,b;
    i=0;
    
    for(y=30;y<424;y++) 
    {
        for(x=46;x<636;x=x+2)
        {
            b= GetPixel(x,y);
            saving_file[i]= b;
            delay();
            i=i+2;
        }
    }
    
}

//--------------------------------------------------------------------------------------//

//Module to display the initial background image on the VGA screen
initialScreen()
{
    unsigned int x,y,i,b;
    i=0;
    
    for(y=0;y<480;y++) 
    {
        for(x=0;x<640;x=x+2)
        {
            b= initial_image[i] << 8;
            b = b | initial_image[i+1];
            initialPutPixel(x,y,b);
            i=i+2;
        }
    }
}

//--------------------------------------------------------------------------------------//